---------------------------------
-- TwentyFive - Remake by Enbi --
----- Originally by cawfee! -----
---------------------------------
-- cawfee's Documentation left --
-- in, plus have added my own! --
---------------------------------

-- Handy Dandy Warlock Check! (Makes sure the Player is a Warlock):

if select(2, UnitClass("player")) ~= "WARLOCK" then return end

-- Declaration of TF and the AntiSpam Variables:
-- (The AntiSpam Variables prevent the reporting of certain things when they are set to 1).

TF = {} -- TwentyFive

-- The Comments below each of these describes which report that Variable will prevent the Spamming of.

   -- AntiSpam Variables
local TF_First_Warn_Reset = 0
local Second_Warn_Reset = 0
local TF_Total_Reset = 0

    -- Colour Codes
local string ColourRed = "|c00ff0000"
local string ColourOrange = "|c00ff8000"
local string ColourGreen = "|c001aea34"
local string ColourPurple = "|c00800080"
local string ColourCream = "|c00fed78d"
local string ColourWhite = "|cffffffff"

    -- Percentages
local TF_Const_HPC = 45
    -- HighPercent
local TF_Const_MPC = 30
    -- MediumPercent
local TF_Const_LPC = 20
    -- LowPercent

-- The core coding:

function TF.OnEvent()   
    if ( event == "UNIT_HEALTH" ) then
        if (tfio == 1) then
        -- If TwentyFive is switched off, the Selection stops.
	
            if ( Specc == 0 ) then
    	        -- Affliction
    		TF_Const_HPC = 35  
    		TF_Const_MPC = 30
    		TF_Const_LPC = 25
	    else
    		-- Demonology
    		TF_Const_HPC = 45  
    		TF_Const_MPC = 40
    		TF_Const_LPC = 35
	    end	    
            -- Determine which Specc the user is in, and adjust Constants as necessary.
	    if ((UnitHealth("target") > ((UnitHealthMax("target")/100)*TF_Const_HPC))) and (UnitIsDead("target") ~= 1) then
            -- Get UnitHealth% - If > HighPercent, resets the AntiSpam Variables.
                TF_Total_Reset = 0
                TF_First_Warn_Reset = 0
                TF_Second_Warn_Reset = 0
            elseif ((UnitHealth("target") <= ((UnitHealthMax("target")/100)*TF_Const_HPC))) and ((UnitHealth("target") > ((UnitHealthMax("target")/100)*TF_Const_MPC))) and (UnitIsDead("target") ~= 1) then
                -- If UnitHealth% is between HighPercent and MediumPercent, and the AntiSpam is Off, then reports to ChatLog and FakedRaidWarning, then turns AntiSpam On.
                if (TF_First_Warn_Reset == 0) then
                    DEFAULT_CHAT_FRAME:AddMessage(ColourCream..UnitName("target")..ColourRed.." is at "..TF_Const_HPC.."%!")
		    RaidNotice_AddMessage(RaidBossEmoteFrame, ColourCream..UnitName("target")..ColourRed.." is at "..TF_Const_HPC.."%!", ChatTypeInfo["RAID_WARNING"])
		    TF_First_Warn_Reset = 1
                end
            elseif ((UnitHealth("target") <= ((UnitHealthMax("target")/100)*TF_Const_MPC))) and ((UnitHealth("target") > ((UnitHealthMax("target")/100)*TF_Const_LPC))) and (UnitIsDead("target") ~= 1) then
                -- If UnitHealth% is between MediumPercent and LowPercent, and the AntiSpam is Off, then reports to ChatLog and FakedRaidWarning, then turns AntiSpam On.                
                if (TF_Second_Warn_Reset == 0) then
		    DEFAULT_CHAT_FRAME:AddMessage(ColourCream..UnitName("target")..ColourOrange.." is at "..TF_Const_MPC.."%!")
		    RaidNotice_AddMessage(RaidBossEmoteFrame, ColourCream..UnitName("target")..ColourOrange.." is at "..TF_Const_MPC.."%!", ChatTypeInfo["RAID_WARNING"])
                    TF_Second_Warn_Reset = 1
                end
            elseif ((UnitHealth("target") <= ((UnitHealthMax("target")/100)*TF_Const_LPC))) and (UnitIsDead("target") ~= 1) then
                -- If UnitHealth% is less than or equal to LowPercent, and the AntiSpam is Off, then reports to ChatLog and FakedRaidWarning, then turns AntiSpam On.                
                if (TF_Total_Reset == 0) then 
		    DEFAULT_CHAT_FRAME:AddMessage(ColourCream..UnitName("target")..ColourGreen.." is at "..TF_Const_LPC.."%! Execute NOW!")
		    RaidNotice_AddMessage(RaidBossEmoteFrame, ColourCream..UnitName("target")..ColourGreen.." is at "..TF_Const_LPC.."%! Execute NOW!", ChatTypeInfo["RAID_WARNING"])
                    TF_Total_Reset = 1
                end
            end
        end
    end
end
 
-- Defining the Frame that TwentyFive will occupy:
 
local f = CreateFrame("Frame",nil,UIParent)
f:RegisterEvent("UNIT_HEALTH")
f:SetScript("OnEvent", TF.OnEvent)

-- This function defines how to handle the TwentyFive Slash Commands:

SLASH_TF1 = '/tf'
    local function handler(msg, editbox)
        local TheCommand, TheRest = msg:match("^(%S*)%s*(.-)$");
        -- Any leading non-whitespace is captured into TheCommand;
        -- The rest, (minus leading whitespace) is captured into TheRest.
        if (tostring(TheCommand)) == "on" and TheRest == "" then
        -- /tf on
            tfio = 1 -- Sets the On/Off Variable to On.
            DEFAULT_CHAT_FRAME:AddMessage(ColourCream.."Enbi's"..ColourWhite.." TwentyFive-Remake "..ColourCream.."is now"..ColourGreen.." ON"..ColourCream..". Hurray!");
            -- ChatLog output.
        elseif (tostring(TheCommand)) == "off" and TheRest == "" then
        -- /tf off
            tfio = 0 -- Sets the On/Off Variable to Off.
            DEFAULT_CHAT_FRAME:AddMessage(ColourCream.."Enbi's"..ColourWhite.." TwentyFive-Remake "..ColourCream.."is now"..ColourRed.." OFF"..ColourCream..". Boo, hiss!");
            -- ChatLog output.
        elseif ((tostring(TheCommand)) == "affli") or ((tostring(TheCommand)) == "affliction") and TheRest == "" then
        -- /tf affli 
        -- /tf affliction
            Specc = 0 -- Sets the Specc to Affliction.
            DEFAULT_CHAT_FRAME:AddMessage(ColourCream.."Enbi's"..ColourWhite.." TwentyFive-Remake "..ColourCream.."set to: "..ColourPurple.."Affliction"..ColourCream..". PewPew.");
            -- ChatLog output.
        elseif ((tostring(TheCommand)) == "demo") or ((tostring(TheCommand)) == "demonology") and TheRest == "" then
        -- /tf demo
        -- /tf demonology
            Specc = 1 -- Sets the Specc to Demonology
            DEFAULT_CHAT_FRAME:AddMessage(ColourCream.."Enbi's"..ColourWhite.." TwentyFive-Remake "..ColourCream.."set to: "..ColourOrange.."Demonology"..ColourCream..". PewPew.");
            -- ChatLog output.
        else
        -- /tf
        -- /tf <insert random non-existential command>
        -- etc
            DEFAULT_CHAT_FRAME:AddMessage(ColourCream.."Enbi's TwentyFive-Remake Commands:");
	    DEFAULT_CHAT_FRAME:AddMessage(ColourCream.." - Turn"..ColourWhite.." TwentyFive-Remake"..ColourCream.." On/Off: "..ColourWhite.."'/tf "..ColourGreen.."on"..ColourWhite.."'"..ColourCream.." and "..ColourWhite.."'/tf "..ColourRed.."off"..ColourWhite.."'"..ColourCream..".")
            DEFAULT_CHAT_FRAME:AddMessage(ColourCream.." - Set"..ColourWhite.." TwentyFive-Remake"..ColourCream.." to Demonology: "..ColourWhite.."'/tf "..ColourOrange.."demo"..ColourWhite.."'"..ColourCream.." ("..ColourWhite.."or "..ColourOrange.."demonology"..ColourCream..").")
            DEFAULT_CHAT_FRAME:AddMessage(ColourCream.." - Set"..ColourWhite.." TwentyFive-Remake"..ColourCream.." to Affliction: "..ColourWhite.."'/tf "..ColourPurple.."affli"..ColourWhite.."'"..ColourCream.." ("..ColourWhite.."or "..ColourPurple.."affliction"..ColourCream..").")
            -- ChatLog output (a list of available Slash Commands for TwentyFive).
        end        
    end
SlashCmdList["TF"] = handler;
-- Assigns the SlashCmdList for TwentyFive to the 'handler' function outlined above.
